#include<iostream>
#include<fstream>
#include<string>

class Intpix_Data
{
 public:
  unsigned int event;
  bool calib;
  unsigned short IntTime;
  unsigned short RSTLength;
  unsigned short ScanTime;
  unsigned short RSTV;
  unsigned short adc[128][128];
};

int main(int argc, char** argv){
  Intpix_Data data;
  int CAmin, CAmax, RAmin, RAmax;
  if(!(argc==6 || argc==2)){
    std::cout<<"DispData Usage :"<<std::endl;
    std::cout<<"$ ./DispData <FilePath> <DispCAmin> <DispCAmax> <DispRAmin> <DispRAmax>"<<std::endl;
    std::cout<<"(default RAmin,CAmin=0, RAmax,CAmax=20)"<<std::endl;
    exit(1);
  }else if(argc==6){
    CAmin = atoi(argv[2]);
    CAmax = atoi(argv[3]);
    RAmin = atoi(argv[4]);
    RAmax = atoi(argv[5]);
  }else if(argc==2){
    CAmin = 0;
    CAmax = 20;
    RAmin = 0;
    RAmax = 20;
  }
  if(128<CAmax || 128<RAmax){
    std::cout<<"RAmax or CAmax is greater than 128!"<<std::endl;
    std::cout<<"Exit!"<<std::endl;
    exit(1);
  }
  if(CAmin<0 || RAmin<0){
    std::cout<<"RAmin or CAmin is smaller than 0!"<<std::endl;
    std::cout<<"Exit!"<<std::endl;
    exit(1);
  }
  if(CAmax<CAmin){
    std::cout<<"CAmin is greater than CAmax!"<<std::endl;
    std::cout<<"Exit!"<<std::endl;
    exit(1);
  }
  if(RAmax<RAmin){
    std::cout<<"RAmin is greater than RAmax!"<<std::endl;
    std::cout<<"Exit!"<<std::endl;
    exit(1);
  }

  std::string str;
  str = argv[1];
  std::cout<<argv[0]<<std::endl;
  std::ifstream fin(str.c_str(), std::ios::in | std::ios::binary);

  int n=0;
  while(1){
    fin.read((char*)&data, sizeof(data));
    if(fin.eof())break;
    n++;

    if(n%10==0){
      if(data.calib)std::cout<<"calib event : "<<data.event<<" "<<std::endl;
      else std::cout<<"physics event : "<<data.event<<std::endl;
      std::cout<<"IntTime="<<data.IntTime<<", RSTLength="<<data.RSTLength;
      std::cout<<", ScanTime="<<data.ScanTime<<", RSTV="<<data.RSTV<<std::endl;
      
      //if(n%10==0){
      for(int i=RAmin; i<RAmax; i++){
	for(int j=CAmin; j<CAmax; j++){
	  std::cout<<data.adc[i][j]<<" ";
	}
	std::cout<<std::endl;
      }
    }
    //if(n==200) break;
  }
  std::cout<<"total event : "<< n<<std::endl;
  fin.close();

  return 0;
}
